/*
File: BGui.c (C) 1998 Dan Huizenga (Skis)
Web: http://www.concentric.net/~skis
E/M: skis@concentric.net

BGui -- A win-95 like drop in replacement for the Allegro GUI.
All errors in this file are (C) 1998 Dan Huizenga. If you used these
routines in your program, all that I ask is E-Mail me about what your
program does, and send me a copy if I request it.
*/

#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include <allegro.h>
#include "tdgui.h"
#include "binterna.h"

//(Proc)    (x, y, w, h)    (Dialog) (zorder)  (Flags) (d1, d2) (dp)       
/*
   color constants used to draw billgui routines. Want to change the colors?
   use these, NOT the fg/bg properties of the dialogs
   For slightly more detailed descriptions of what the stuff in this file
   does, look at tdgui.h.
*/

float bg_ver = 1;
char bg_ver_str[255] = "1.0 BETA -- PLEASE UPDATE";


#define A_S1  0
#define A_S2  1
#define A_S3  2
#define A_B1  3
#define A_B2  4
#define A_B3  5


static DIALOG billalert_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_billwin_proc,        0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL },
   { d_billctext_proc,      0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL },
   { d_billctext_proc,      0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL },
   { d_billbutton_proc,     0,    0,    0,    0,    0,    0,    0,    D_EXIT,  0,    0,    NULL },
   { d_billbutton_proc,     0,    0,    0,    0,    0,    0,    0,    D_EXIT,  0,    0,    NULL },
   { d_billbutton_proc,     0,    0,    0,    0,    0,    0,    0,    D_EXIT,  0,    0,    NULL },
   { NULL }
};

void bill_init() {
 bill_init_radio_buttons(); 
 gui_mouse_focus = 0;

 metrics.wn_titlebar_h = 10;
 metrics.wn_border_size = 2;
}

int get_gui_mode()
{
 int ret = bill_appearexact;
 return ret;
}

void set_gui_mode(int mode)
{
 if (mode) {
  bill_appearexact = TRUE;
  gui_mouse_focus = FALSE;
 }
 else {
  bill_appearexact = FALSE;
  gui_mouse_focus = TRUE;
 }
}

/*
 ======================
 =   BILL GUI Helpers =
 ======================
*/
int is_in(int xa, int ya, int xb, int yb, int w, int h) {
 int in = TRUE;
 if (xa < xb) in = FALSE;
 if (ya < yb) in = FALSE;
 if (xa > xb+w) in = FALSE;
 if (ya > yb+h) in = FALSE;
 return in;
}



/*
  ==============================
  = BILL GUI dialogs           =
  ==============================
*/

int billalert3(char *s1, char *s2, char *s3, char *b1, char *b2, char *b3, int c1, int c2, int c3)
{
   int maxlen = 0;
   int len1, len2, len3;
   int avg_w = text_length(font, " ");
   int avg_h = text_height(font);
   int buttons = 0;
   int b[3];
   int c;

   #define SORT_OUT_BUTTON(x) {                                            \
      if (b##x) {                                                          \
         billalert_dialog[A_B##x].flags &= ~D_HIDDEN;                          \
         billalert_dialog[A_B##x].key = c##x;                                  \
         billalert_dialog[A_B##x].dp = b##x;                                   \
	 len##x = gui_strlen(b##x);                                        \
	 b[buttons++] = A_B##x;                                            \
      }                                                                    \
      else {                                                               \
         billalert_dialog[A_B##x].flags |= D_HIDDEN;                           \
	 len##x = 0;                                                       \
      }                                                                    \
   }

   billalert_dialog[A_S1].dp = billalert_dialog[A_S2].dp = billalert_dialog[A_S3].dp = 
                           billalert_dialog[A_B1].dp = billalert_dialog[A_B2].dp = "";

   if (s1) {
      billalert_dialog[A_S1].dp = s1;
      maxlen = text_length(font, s1);
   }

   if (s2) {
      billalert_dialog[A_S2].dp = s2;
      len1 = text_length(font, s2);
      if (len1 > maxlen)
	 maxlen = len1;
   }

   if (s3) {
      billalert_dialog[A_S3].dp = s3;
      len1 = text_length(font, s3);
      if (len1 > maxlen)
	 maxlen = len1;
   }

   SORT_OUT_BUTTON(1);
   SORT_OUT_BUTTON(2);
   SORT_OUT_BUTTON(3);

   len1 = MAX(len1, MAX(len2, len3)) + avg_w*3;
   if (len1*buttons > maxlen)
      maxlen = len1*buttons;

   maxlen += avg_w*4;
   billalert_dialog[0].w = maxlen;
   billalert_dialog[A_S2].x = billalert_dialog[A_S3].x = 
                                                billalert_dialog[0].x + maxlen/2;

   billalert_dialog[A_B1].w = billalert_dialog[A_B2].w = billalert_dialog[A_B3].w = len1;

   billalert_dialog[A_B1].x = billalert_dialog[A_B2].x = billalert_dialog[A_B3].x = 
                                       billalert_dialog[0].x + maxlen/2 - len1/2;

   if (buttons == 3) {
      billalert_dialog[b[0]].x = billalert_dialog[0].x + maxlen/2 - len1*3/2 - avg_w;
      billalert_dialog[b[2]].x = billalert_dialog[0].x + maxlen/2 + len1/2 + avg_w;
   }
   else if (buttons == 2) {
      billalert_dialog[b[0]].x = billalert_dialog[0].x + maxlen/2 - len1 - avg_w;
      billalert_dialog[b[1]].x = billalert_dialog[0].x + maxlen/2 + avg_w;
   }

   billalert_dialog[0].h = avg_h*8;
   billalert_dialog[A_S2].y = billalert_dialog[0].y + avg_h*2 +5;
   billalert_dialog[A_S3].y = billalert_dialog[0].y + avg_h*3 +5;
   billalert_dialog[A_S2].h = avg_h;

   billalert_dialog[A_B1].y = billalert_dialog[A_B2].y = billalert_dialog[A_B3].y = 
                                                billalert_dialog[0].y + avg_h*5;

   billalert_dialog[A_B1].h = billalert_dialog[A_B2].h = billalert_dialog[A_B3].h = avg_h*2;

   centre_dialog(billalert_dialog);

   clear_keybuf();

   do {
   } while (mouse_b);

   c = moveable_do_dialog(billalert_dialog, A_B1);

   if (c == A_B1)
      return 1;
   else if (c == A_B2)
      return 2;
   else
      return 3;
}

int billalert(char *s1, char *s2, char *s3, char *b1, char *b2, int c1, int c2)
{
   int ret;

   ret = billalert3(s1, s2, s3, b1, b2, NULL, c1, c2, 0);

   if (ret > 2)
      ret = 2;

   return ret;
}

void _draw_arrow(int x, int y, int basew, int colr, int stl) {
 int sx;
 int sy;
 int xp;
 int yp;
 int w, h;

 if (stl == SCL_LEFTARROW) {
  sx = x + basew/2;
  h=basew;
  if (h % 2 > 0) h--;
  for(xp = sx, yp = y; h>=0; xp--, yp++, h-=2) {
   vline(screen, xp, yp, yp+h, colr); 
  }
 }
 else if (stl == SCL_RIGHTARROW) {
  sx = x;
  h=basew;
  if (h % 2 > 0) h--;
  for(xp = sx, yp = y; h>=0; xp++, yp++, h-=2) {
   vline(screen, xp, yp, yp+h, colr); 
  }
 }
 else if (stl == SCL_UPARROW) {
  sy = y;
  w=0;
  if (h % 2 > 0) h--;
  for(yp = sy, xp = x+basew/2; w<=basew; yp++, xp--, w+=2) {
   hline(screen, xp, yp, xp+w, colr); 
  }
 }
 else if (stl == SCL_DOWNARROW) {
  sy = y;
  w=basew;
  if (h % 2 > 0) h--;
  for(yp = sy, xp = x; w>=0; yp++, xp++, w-=2) {
   hline(screen, xp, yp, xp+w, colr); 
  }
 }
}


void bill_fade_bmp(BITMAP *bmp, int clr) {
 int yoff;
 int ysub;
 int xoff;
 int xadd;
 show_mouse(NULL);
 for(yoff=0; yoff<=SCREEN_H; yoff +=2) {
  for(ysub=0; ((yoff-ysub)>=0);ysub++)
   putpixel(bmp, ysub, yoff-ysub, clr);
 }

 for(xoff=0; xoff<=SCREEN_W; xoff +=2) {
  for(xadd=0; ((xoff+xadd)<=SCREEN_W); xadd++)
   putpixel(bmp, xoff+xadd, SCREEN_H-xadd, clr);
 }
 show_mouse(screen);
}

void bill_slowfade_bmp(BITMAP *bmp, int clr) {
 int yoff;
 int ysub;
 int xoff;
 int xadd;

 for(yoff=0; yoff<=SCREEN_H; yoff +=2) {
 vsync();
  for(ysub=0; ((yoff-ysub)>=0);ysub++)
   putpixel(bmp, ysub, yoff-ysub, clr);
 }

 for(xoff=0; xoff<=SCREEN_W; xoff +=2) {
 vsync();
  for(xadd=0; ((xoff+xadd)<=SCREEN_W); xadd++)
   putpixel(bmp, xoff+xadd, SCREEN_H-xadd, clr);
 }
}


void replace_col(BITMAP *b, int oc, int nc)
{
 int x;
 int y;
 for (y=0; y<=b->h; y++) {
  for (x=0; x<=b->w; x++) {
   if (getpixel(b, x, y) == oc)
    putpixel(b, x, y, nc);
  }
 }
}

void make_solid_pal(PALETTE pal, int start, int stop, int r, int g, int b)
{
 int counter;
 RGB color = {r, g, b};
 for (counter=start; counter<=stop; counter++) {
  pal[counter] = color;
 }
}
/*
  ==============================
  =  Stuff that didn't fit in  =
  ==============================
*/
int init_moveable(DIALOG *dialog)
{
 BITMAP *bmp;
 bmp = create_bitmap(dialog->w+1, dialog->h+1); 

 if (bmp) {
  show_mouse(NULL);
  blit(screen, bmp, dialog->x, dialog->y, 0, 0, dialog->w+1, dialog->h+1);
  show_mouse(screen);
 }

 dialog->dp3 = bmp;


 return 0;
}

int shutdown_moveable(DIALOG *dialog)
{
 if (dialog->dp3) {
  show_mouse(NULL);
  blit(dialog->dp3, screen, 0, 0, dialog->x, dialog->y, dialog->w+1, dialog->h+1);
  destroy_bitmap(dialog->dp3);
  show_mouse(screen);
 }


 return 0;
}

int moveable_do_dialog(DIALOG *dialog, int focus_obj)
{
   int ret;
   init_moveable(dialog);
   ret = do_dialog(dialog, focus_obj);
   shutdown_moveable(dialog);
   return ret;
}

