/*
 *   NPC link checker 1.0
 *
 *   This is a quick hack, not the epitomy of optimisation or coding style
 *   Should be portable though
 *
 *   This program is in the public domain
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#if defined( __linux__) || defined(__BEOS__)
#define NO_STRICMP
#endif

char **pageindex;
int pages;


#ifdef NO_STRICMP
int stricmp(char *a,char *b)
{
for(;*a;a++,b++)
	if(tolower(*a) != tolower(*b))
		return 1;
return 0;
}
#endif



int find_page(char *page)
{
int ctr;

// Check for intrinsics
if(!stricmp(page,"exit"))
	return 1;

// Check page index
for(ctr=0;ctr<pages;ctr++)
	if(!stricmp(page,pageindex[ctr]))
		return 1;
return 0;
}

void process_file(char *fname)
{
FILE *fp;
char buffer[1024];
int ctr,line,errors,links;
char *p,*ptr1,*ptr2;

printf("Checking %s\n",fname);

fp=fopen(fname,"r");
if(!fp)
	{
	printf("Cannot open file %s\n",fname);
	return;
	}

errors=0;

// First, count pages

pages=0;
do
	{
	fgets(buffer,1024,fp);
	if(strstr(buffer,"[page=\""))
		pages++;
	} while(!feof(fp));

if(!pages)
	{
	printf("No pages defined!\n");
	fclose(fp);
	return;
	}

// Now allocate room for the pages

pageindex=(char **)calloc(pages,sizeof(char *));
if(!pageindex)
	{
	printf("Could not allocate page index, quitting\n");
	exit(1);
	}

for(ctr=0;ctr<pages;ctr++)
	{
	pageindex[ctr]=(char *)malloc(128);
	if(!pageindex[ctr])
		{
		printf("Out of memory, quitting\n");
		exit(1);
		}
	}

// Back to start
fseek(fp,0L,SEEK_SET);

// Now read in the page index

ctr=0;
line=0;
do
	{
	fgets(buffer,1024,fp);
	line++;
	if(strstr(buffer,"[page=\""))
		{
		// Find opening quote
		ptr1=strchr(buffer,'\"');
		ptr1++;
		// Find ending quote
		ptr2=strrchr(ptr1,'\"');
		if(!ptr2)
			{
			printf("No ending quote in page declaration at line %d\n",line);
			errors++;
			continue;
			}
		*ptr2=0; // Kill the ending quote
		strcpy(pageindex[ctr],ptr1);
		ctr++;
		}
	} while(!feof(fp));


// Back to start again
fseek(fp,0L,SEEK_SET);

// Now find the links

line=0;
do
	{
	fgets(buffer,1024,fp);
	line++;

	// If it's a page declaration, reset links count
	if(strstr(buffer,"[page=\""))
		links=0;
	// If end of page and no links, there's a problem
	if(strstr(buffer,"[endpage]"))
		if(!links)
			{
			printf("Page has no links at line %d\n",line);
			errors++;
			}

	// Check for links
	p=strstr(buffer,"[goto=\"");
	if(!p)
		{
		p=strstr(buffer,"linkto=\"");
		if(p)
			links++;
		else
			{
			p=strstr(buffer,"[nextpage=\"");
			if(p)
				links++;
			}
		}

	// Check

	if(p)
		{
		// Find opening quote
		ptr1=strchr(p,'\"');
		ptr1++;
		// Find ending quote
		ptr2=strrchr(ptr1,'\"');
		if(!ptr2)
			{
			printf("No ending quote in link at line %d\n",line);
			errors++;
			continue;
			}
		*ptr2=0; // Kill the ending quote
		if(!find_page(ptr1))
			{
			printf("Page '%s' not found in link at line %d\n",ptr1,line);
			errors++;
			}
		}
	} while(!feof(fp));

if(errors)
	printf("%d errors found\n",errors);
else
	printf("No errors\n");


// Free everything and quit

for(ctr=0;ctr<pages;ctr++)
	free(pageindex[ctr]);
free(pageindex);
}


int main(int argc,char *argv[])
{
int ctr;

if(argc<2)
	{
	printf("NPC link checker\n");
	printf("Syntax: checknpc <filenames>\n");
	exit(1);
	}

for(ctr=1;ctr<argc;ctr++)
	process_file(argv[ctr]);
return 0;
}
