/*
 *      Game state information
 */

#define LMSIZE 32
//#define VIEWDIST 8 // was 4
#define VIEWDIST 10 // was 4

#ifdef __cplusplus
extern "C" {
#endif

extern OBJECT *syspocket;          // Storage area for GUI objects
extern OBJECT *player;             // The player
extern OBJECT *victim;             // Global variable
extern OBJECT *person;             // Current person being moved
extern OBJECT *current_object;     // Global variable
extern TILE *current_tile;         // Global variable
extern int *storage;               // Integer storage space for SEER
extern OBJECT **party;
extern char **partyname;
extern WORLD *curmap;               // pointer to current world
extern WORLD worldcache[];

extern unsigned int game_minute;     // Must be INT or SeeR will have a hissy fit
extern unsigned int game_hour;
extern unsigned int game_day;
extern unsigned int game_month;
extern unsigned int game_year;
extern unsigned int days_passed;
extern unsigned int day_of_week;

extern int mapx,mapy,mapx2,mapy2; // Coordinates for Seer
extern int new_x,new_y;           // Seer parameters
extern int Fader;                 // Lighting control
extern int SoundFixed;            // Stop sounds fading with distance if 1
extern int irekey;                // Key pressed by user
extern int show_roof;             // Project the roof? (Yes)
extern char fullrestore;          // Do we revert all objects to their defaults?
extern int ytab[MAX_H];           // Fast access to parts of the map
extern int buggy;                 // Were warnings detected?
extern int mu_volume,sf_volume;	  // Audio levels

extern OBJECT *largemap[LMSIZE][LMSIZE];  // Large Object caches
extern OBJECT *solidmap[LMSIZE][LMSIZE];
extern OBJLIST *ActiveList;       // List of all active objects

// Cached ID numbers for 'system' VRMs

extern int vscheduler,mainproc,status;
extern int follower,loadproc,all_dead,playervrm,splashpe;
extern int trackstop, update_life,erase_object;

// Resource Data

extern SEQ_POOL *SQlist; // Sequences in the SQlist
extern long SQtot;       // no. of sequences
extern VRM *COlist;      // Array of VRM modules
extern long COtot;       // no. of VRMs present
extern OBJECT *CHlist;   // Array of characters
extern long CHtot;       // no. of characters
extern S_POOL *SPlist;   // Array of sprites
extern long SPtot;       // number of sprites
extern TILE *TIlist;   // Array of sprites
extern long TItot;       // number of sprites
extern S_POOL *RTlist;   // Array of sprites
extern long RTtot;       // number of sprites
extern L_POOL *LTlist;   // Array of sprites
extern long LTtot;       // number of sprites
extern long PEtot;	 // number of user functions
extern PEM *PElist;	// List of user functions
extern char **pe_files;	 // List of user script files (not funcs)

extern long spr_alloc;
extern long seq_alloc;
extern long vrm_alloc;
extern long chr_alloc;
extern long til_alloc;
extern long mus_alloc;
extern long wav_alloc;
extern long rft_alloc;
extern long lgt_alloc;
extern long pef_alloc;

#ifdef __cplusplus
}
#endif
