/*
 *      NuSpeech - A script-based conversation engine
 *                 Beware: the parser is a bit ugly
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ithelib.h"
#include "core.hpp"
#include "textfile.h"
#include "gamedata.h"
#include "console.h"
#include "loadfile.h"
#include "media.h"
#include "init.h"
#include "eggtimer.h"
#include "oscli.h"

#define MAXFLAGS 8192

char tFlag[MAXFLAGS];
char *tFlagIdentifier[MAXFLAGS];

void Wipe_tFlags();
int Get_tFlag(char *name);
void Set_tFlag(char *name,int a);
void NPC_set_lFlag(OBJECT *o,char *page, OBJECT *p, int state);
int NPC_get_lFlag(OBJECT *o,char *page, OBJECT *p);

static int numFlags=0;
static struct TF_S conversation;       // TextFile class instance
static char img[256];
static char curpage[256];
static char autolink[256];
static char esclink[256];
static char temp[256];
static char backing[256];
static char exitvrm[64];
static char links[10][4][256];   // Ten is the number of numeric keys..
static int linkptr,y,link_x;
static unsigned char scan_only=0,link_now=0,link_r,link_g,link_b,def_r,def_g,def_b;
static char *curfile;
static int curline;
static BITMAP *image,*picbuf,*oldpic;
static char picpath[256];
static OBJECT *npc;
static char *objname;

void NPC_Converse(char *file,char *startpage);
void NPC_BeenRead(OBJECT *o,char *page, OBJECT *p);
int NPC_WasRead(OBJECT *o,char *page);
void NPC_ReadWipe(OBJECT *o);
void setPflag(OBJECT *o,int n,int s);
int getPflag(OBJECT *o,int n);

static int  NPC_ParseCode(char *line);
static int  NPC_GetPage(char *line);
static int  NPC_GetEnd(int start);
static int  NPC_GetPageLine(char *page);
static void NPC_ResetLinks();
static void NPC_AddLink(char *msg,char *dest);
static void NPC_AltLinkM(char *msg);
static void NPC_AltLinkD(char *dest);
static void toke(char *string);
static int toker(char *string);
static OBJECT *ChoosePartyMember();

extern int TakeQuantity(OBJECT *container,char *objectname,int qty);
extern void AddQuantity(OBJECT *container,char *objectname,int qty);
extern int MoveQuantity(OBJECT *src,OBJECT *dest,char *objectname,int qty);
extern void Call_VRM(int num);
extern int IsOnscreen(char *pname);
extern int SumObjects(OBJECT *cont, char *name, int total);


/*
 *      NPC_Converse(file,startpage) - User function to start a conversation.
 *                                     File is the path to the conversation
 *                                     file using standard IRE conventions.
 *                                     startpage is a page title, or NULL
 *                                     to use 'start' as the starting page,
 */

void NPC_Converse(char *file,char *startpage)
{
int k,start,end,ctr,lines,talking;
char msg[5];
char buffer[256];
char *linkpage;

// Set the NPC we're talking to, especially if it's a link to another object

if(current_object)
	{
	if(current_object->stats->npcflags.symlink && current_object->stats->owner)
		npc=current_object->stats->owner;
	else
		npc=current_object;
	objname=current_object->personalname;	// Get name of object we're talking to
	}
else
	{
	npc=NULL;
	objname="NoName";
	}

// Set default colour for links to be Navy Blue

link_r = 0;
link_g = 0;
link_b = 160;
def_r = 255;
def_g = 255;
def_b = 255;

link_x = 0;        // Default to X=0, left edge of the screen

// Find the path to load pictures from
// First, get the current path

strcpy(buffer,file);
strslash(buffer);

if(!strrchr(buffer,'/'))
	strcpy(picpath,"pics/");
else
	{
	*strrchr(buffer,'/')=0;
	strcpy(picpath,buffer);
	strcat(picpath,"/pics/");
	}
strcpy(buffer,"\0");

// Create a buffer to preserve game screen state

oldpic = create_bitmap(640,480);
if(!oldpic)
    return;

irecon_savecol(); // Preserve console colour

TF_init(&conversation);

// Ok, now open the conversation

TF_load(&conversation,file);
curfile=file;
//itg_memset(bg_screen,0,itg_blitsize);

blit(swapscreen,oldpic,0,0,0,0,640,480);
clear(swapscreen);

strcpy(backing,"\0");
strcpy(exitvrm,"\0");
strcpy(esclink,"\0");
talking=1;           // Just Keep Talking

if(!startpage)
	start=NPC_GetPage("start");
else
	start=NPC_GetPage(startpage);

if(start==-1)
	{
	irecon_loadcol(); // Restore console colour
	return;
	}

lines=50;
k=-1;
linkptr=-1;

if(lines>conversation.lines)
	lines=conversation.lines;

end=NPC_GetEnd(start);

FlushKeys();
do  {
////    itg_fblit(swapscreen,bg_screen);
	y=128;
	strcpy(img,"\0");
	strcpy(temp,"\0");
	strcpy(curpage,"\0");
	strcpy(autolink,"\0");
	NPC_ResetLinks();

	for(ctr=start;ctr<end;ctr++)
		{
		curline=ctr;
		strcpy(buffer,conversation.line[ctr]);
		toke(buffer);
		if(buffer[0] != '[')
			{
			irecon_printxy(0,y+=8,buffer);
			}
		else
			{
			NPC_ParseCode(buffer);
			// If we have an instantaneous page change, do it
			if(link_now)
				{
				ctr=NPC_GetPage(autolink);
				if(ctr>=0)
					{
					start=ctr;
					end=NPC_GetEnd(start);
////                    itg_fblit(swapscreen,bg_screen);
					y=128;
					strcpy(img,"\0");
					strcpy(temp,"\0");
					strcpy(curpage,"\0");
					strcpy(autolink,"\0");
					NPC_ResetLinks();
					}
				if(ctr == -2)
					goto uncouth_shutdown;   // Bad, bad Doug!
				link_now=0;
				}
			}
		}

	irecon_colour(link_r,link_g,link_b);   // Colour for the menu

	y+=32;
	for(ctr=0;ctr<linkptr;ctr++)
		{
		if(ctr<9)
			itoa(ctr+1,msg,10);
		else
			strcpy(msg,"0");
		irecon_printxy(link_x,y,msg);
		if(links[ctr][3][0]!=0)     // Is there an alternate title?
			{
			if(NPC_WasRead(npc,links[ctr][0])) // Should we use it?
				irecon_printxy(link_x+16,y,links[ctr][3]);   // Yes
			else
				irecon_printxy(link_x+16,y,links[ctr][1]);   // No
			}
		else
			irecon_printxy(link_x+16,y,links[ctr][1]);       // No there wasn't
		y+=8;
		}

	irecon_colour(def_r,def_g,def_b);


	// If no links, print an error and finish

	if(!autolink[0] && !linkptr)
		{
		irecon_colour(255,0,0);
		irecon_printxy(16,y,"Error!  No links on this page.  Press any key to exit..");
		irecon_colour(def_r,def_g,def_b);
		Bug("No links for page '%s' in file '%s'\n",curpage,curfile);
		strcpy(autolink,"exit"); // This will make it exit immediately
		}

	Show();
	FlushKeys();
	k=WaitForKey();
	if(k==KEY_F10)
		BMPshot();
	if(k==KEY_ESC)
		if(esclink[0] == 0)             // Special command for ESC?
			talking=0;                  // No, just exit
		else
			if(stricmp(esclink,"disabled"))     // If not disabled,
				strcpy(autolink,esclink);       // go to the page

	if(autolink[0] != 0)        // If there's an automatic page change
		{
		ctr=NPC_GetPage(autolink);
		if(ctr>=0)
			{
			start=ctr;
			end=NPC_GetEnd(start);
			}
		if(ctr==-2)             // -2 means end-of-conversation
			talking=0;
		}
	else
		{
		ctr = k - KEY_1;
		if(k == KEY_0)
			ctr=9;
		if(ctr>=0 && ctr<linkptr)
			{
			linkpage = links[ctr][0];            // Use the default page

			if(links[ctr][2][0] != 0)            // Is there an alternate?
				if(NPC_WasRead(npc,links[ctr][0])) // Go there?
					linkpage=links[ctr][2];      // Yes we do

			NPC_BeenRead(npc,links[ctr][0],player);     // Mark as read

			start=NPC_GetPage(linkpage);
			if(start==-1)   // Error in code
				{
				irecon_loadcol(); // Restore console colour
				Bug("Conversation: broken link.  Could not find page '%s' in file '%s'\n",linkpage,curfile);
				return;
				}
			if(start==-2)   // End of conversation
				talking = 0;
			end=NPC_GetEnd(start);
			}
		}

	} while(talking);

uncouth_shutdown:

FlushKeys();

TF_term(&conversation);
//display_backing("backings/panel.pcx",(short *)swapscreen);
blit(oldpic,swapscreen,0,0,0,0,640,480);
destroy_bitmap(oldpic);

irecon_loadcol(); // Restore console colour

k = (exitvrm[0]!='\0'?getnum4VRM(exitvrm):0);
if(k>0)
	{
	person = npc;
	Call_VRM(k);
	}
}

/*
 *      NPC_ParseCode(line) - Parse the given line and return an opcode.
 *                            This is the core of the conversation engine.
 */


int NPC_ParseCode(char *line)
{
char line1[1024];
char line2[1024];
char filename[1024];
char *pos;
OBJECT *obj;
int rgb,r,g,b;

if(!line)
    return 0;

strcpy(line1,line);

strdeck(line1,'[');
strdeck(line1,'\"');
strdeck(line1,']');
strdeck(line1,0xa);
strdeck(line1,0xd);
strstrip(line1);

strcpy(line2,strfirst(line1));

if(!stricmp(line2,"page") || !stricmp(line2,"page="))
    {
    strcpy(curpage,strrest(line1));
    strstrip(curpage);
    return 2;
    }

if(!stricmp(line2,"endpage"))
    return 3;

/*
if(!stricmp(line2,"backing") || !stricmp(line2,"backing="))
    {
    strcpy(backing,"pics/");
    strcat(backing,rest(line1));
    deck(backing,'\"');
    deck(backing,']');
    display_backing(backing,(short *)bg_screen);
    itg_fblit(swapscreen,bg_screen);
    return 13;
    }
*/

if(!stricmp(line2,"link_colour=") || !stricmp(line2,"link_color=")
|| !stricmp(line2,"linkcolour=") || !stricmp(line2,"linkcolor=")
|| !stricmp(line2,"links=") || !stricmp(line2,"links="))
    {
    pos=strchr(line,'#');
    if(!pos)
        {
        Bug("Colour is not specified properly in %s:%d\n",curfile,curline);
        return 30;
        }
    pos++;
    strcpy(line2,pos);  // Isolate just the hex number
    line2[7]=0;
    sscanf(line2,"%x",&rgb);   // Got it in binary.
    r=(rgb>>16)&0xff;   // get Red
    g=(rgb>>8)&0xff;    // get green
    b=rgb&0xff;         // get blue

    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Colour is not specified properly in %s:%d\n",curfile,curline);
        return 30;
        }

    // Use this colour for the menu links

    link_r = r;
    link_g = g;
    link_b = b;

    return 30;
    }

if(!stricmp(line2,"link_offset=") || !stricmp(line2,"linkoffset=")
|| !stricmp(line2,"link_x=") || !stricmp(line2,"linkx="))
    {
    pos=strchr(line,'=');
    if(!pos)
        {
        Bug("Missing = in %s:%d\n",curfile,curline);
        return 31;
        }
    pos++;
    strcpy(line2,pos);  // Isolate just the hex number
    strdeck(line2,']');
    strdeck(line2,'\"');
    sscanf(line2,"%d",&rgb);   // Got it in binary.

    // Use this offset for the menu links

    link_x = rgb;

    return 31;
    }

if(scan_only)
    return 0;

if(!stricmp(line2,"backing") || !stricmp(line2,"backing="))
    {
    strcpy(img,strrest(line1));
    strstrip(img);

    // IMG is now the name of the sprite to be used

    strcpy(temp,picpath);
    strcat(temp,img);
    if(loadfile(temp,filename))
        {
        picbuf = iload_bitmap(filename);
		clear(swapscreen);
        masked_blit(picbuf,swapscreen,0,0,0,0,picbuf->w,picbuf->h);
        destroy_bitmap(picbuf);
//        display_backing(filename,(short *)bg_screen);
//        itg_fblit(swapscreen,bg_screen);
        }
    else
        {
        irecon_colour(255,0,0);
        irecon_printxy(8,8,temp); // Print duff filename
        irecon_colour(def_r,def_g,def_b);
        Bug("Could not load image file '%s' in %s\n",temp,curfile);
        }
    return 13;
    }

if(!stricmp(line2,"image") || !stricmp(line2,"image="))
    {
    strcpy(img,strrest(line1));
    strstrip(img);

    // IMG is now the name of the sprite to be used

    strcpy(temp,picpath);
    strcat(temp,img);
    if(loadfile(temp,filename))
        {
        image=iload_bitmap(filename);
        draw_sprite(swapscreen,image,(640-image->w)/2,0);
        r = image->h;
        if(r>128)                   // If it's bigger than 128 pixels
            y=r+16;                 // then make room for it.
        destroy_bitmap(image);
        }
    else
        {
        irecon_colour(255,0,0);
        irecon_printxy(8,8,temp); // Print duff filename
        irecon_colour(def_r,def_g,def_b);
        Bug("Could not load image file '%s' in %s\n",temp,curfile);
        }

    return 1;
    }

if(!stricmp(line2,"nextpage") || !stricmp(line2,"nextpage="))
    {
    if(autolink[0]!=0)  // Already an automatic link.  Use by preference.
        {
//        boot2("!! Multple Links attempted new = %s\n",rest(line1));
        return 4;
        }
    strcpy(autolink,strrest(line1));
    strstrip(autolink);
    return 4;
    }

if(!stricmp(line2,"goto") || !stricmp(line2,"goto="))
    {
    strcpy(line2,strrest(line1));
    strstrip(line2);
    if(NPC_GetPageLine(line2) == -1)
        {
        Bug("Page not found for [goto=\"%s\"] in %s:%d\n",line2,curfile,curline);
//        strcpy(autolink,"exit");
        }
    else
        {
        strcpy(autolink,line2);
        link_now=1;
        }
    return 4;
    }

if(!stricmp(line2,"link") || !stricmp(line2,"link="))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    return 5;
    }

if(!stricmp(line2,"linkto") || !stricmp(line2,"linkto="))
    {
    NPC_AddLink(strrest(line1),temp);
    strcpy(temp,"\0");
    return 6;
    }

if(!stricmp(line2,"alt_link") || !stricmp(line2,"alt_link=")
|| !stricmp(line2,"altlink") || !stricmp(line2,"altlink="))
    {
    NPC_AltLinkM(strrest(line1));
    return 5;
    }

if(!stricmp(line2,"alt_linkto") || !stricmp(line2,"alt_linkto=")
|| !stricmp(line2,"altlinkto") || !stricmp(line2,"altlinkto="))
    {
    NPC_AltLinkD(strrest(line1));
    return 6;
    }

if(!stricmp(line2,"once"))
    {
    if(linkptr == 0)
        {
        Bug("[once] before [link_to] in %s:%d, should come last\n",curfile,curline);
        return 6;
        }
    if(NPC_WasRead(npc,links[linkptr-1][0])) // If it's been read
        {                                              // remove it
        linkptr--;
        strcpy(links[linkptr][0],"\0");
        strcpy(links[linkptr][1],"\0");
        strcpy(links[linkptr][2],"\0");
        strcpy(links[linkptr][3],"\0");
        }
    return 6;
    }


if(!stricmp(line2,"if"))
    {
    if(!Get_tFlag(strfirst(strrest(line1))))
        return 8;
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 8;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 8;
    }

if(!stricmp(line2,"if_not"))
    {
    if(Get_tFlag(strfirst(strrest(line1))))
        return 8;
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 8;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 8;
    }

if(!stricmp(line2,"if_local"))
    {
    if(!NPC_get_lFlag(npc,strfirst(strrest(line1)),player))
        return 8;
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 8;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 8;
    }

if(!stricmp(line2,"if_not_local"))
    {
    if(NPC_get_lFlag(npc,strfirst(strrest(line1)),player))
        return 8;
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 8;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 8;
    }

if(!stricmp(line2,"call") || !stricmp(line2,"call=")
|| !stricmp(line2,"callvrm") || !stricmp(line2,"callvrm=")
|| !stricmp(line2,"call_vrm") || !stricmp(line2,"call_vrm="))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = (temp[0]!='\0'?getnum4VRM(temp):0);
    if(r>0)
        {
        person = npc;
        Call_VRM(r);
        }
    strcpy(temp,"\0");
    return 9;
    }

if(!stricmp(line2,"set"))
    {
    Set_tFlag(strfirst(strrest(line1)),1);
    return 10;
    }

if(!stricmp(line2,"clr") || !stricmp(line2,"clear"))
    {
    Set_tFlag(strfirst(strrest(line1)),0);
    return 10;
    }

if(!stricmp(line2,"set_local"))
    {
    NPC_set_lFlag(npc,strfirst(strrest(line1)),player,1);
    return 10;
    }

if(!stricmp(line2,"clr_local") || !stricmp(line2,"clear_local"))
    {
    NPC_set_lFlag(npc,strfirst(strrest(line1)),player,0);
    return 10;
    }

if(!stricmp(line2,"colour=") || !stricmp(line2,"color="))
    {
    pos=strchr(line,'#');
    if(!pos)
        {
        Bug("Colour is not specified properly in %s:%d\n",curfile,curline);
        return 11;
        }
    pos++;
    strcpy(line2,pos);  // Isolate just the hex number
    line2[7]=0;
    sscanf(line2,"%x",&rgb);   // Got it in binary.
    r=(rgb>>16)&0xff;   // get Red
    g=(rgb>>8)&0xff;    // get green
    b=rgb&0xff;         // get blue

    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Colour is not specified properly in %s:%d\n",curfile,curline);
        return 11;
        }
    pos++;

def_r = r;
def_g = g;
def_b = b;
irecon_colour(def_r,def_g,def_b);


//    irecon_colour(r,g,b);
    strcpy(line2,pos);
    toke(line2);
    irecon_printxy(0,y+=8,line2);
//    irecon_colour(def_r,def_g,def_b);
    return 11;
    }

if(!stricmp(line2,"remove") || !stricmp(line2,"destroy"))
    {
    strcpy(temp,strgetword(line,2));
    r = atoi(temp);
    strcpy(temp,strgetword(line,3));
    strdeck(temp,']');
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    if(TakeQuantity(player,temp,r))
        {
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        }
    return 12;
    }

if(!stricmp(line2,"create"))
    {
    strcpy(temp,strgetword(line,2));
    r = atoi(temp);
    strcpy(temp,strgetword(line,3));
    strdeck(temp,']');
    strstrip(temp);
    AddQuantity(player,temp,r);
    return 12;
    }

if(!stricmp(line2,"set_personal_flag")|| !stricmp(line2,"set_pflag"))
    {
    setPflag(npc,atoi(strgetword(line1,2)),1);
    return 14;
    }

if(!stricmp(line2,"clear_personal_flag") || !stricmp(line2,"clear_pflag")
|| !stricmp(line2,"clr_personal_flag")|| !stricmp(line2,"clr_pflag"))
    {
    setPflag(npc,atoi(strgetword(line1,2)),0);
    return 14;
    }

if(!stricmp(line2,"if_pflag") || !stricmp(line2,"ifpflag")
|| !stricmp(line2,"if_personal_flag") || !stricmp(line2,"ifpersonalflag"))
    {
    if(!getPflag(npc,atoi(strgetword(line1,2))))
        return 15;                                      // If not true, abort
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 15;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 15;
    }

if(!stricmp(line2,"if_npflag") || !stricmp(line2,"ifnpflag")
|| !stricmp(line2,"if_not_pflag") || !stricmp(line2,"ifnotpflag")
|| !stricmp(line2,"if_not_personal_flag") || !stricmp(line2,"ifnotpersonalflag"))
    {
    if(getPflag(npc,atoi(strgetword(line1,2))))
        return 15;                                    // If true, abort
    pos=strchr(line,']');
    if(!pos)
        {
        Bug("Missing ] in %s:%d\n",curfile,curline);
        return 15;
        }
    pos++;

    if(pos[0]=='[')
        return(NPC_ParseCode(pos));
    else
        irecon_printxy(0,y+=8,pos);
    return 15;
    }

if(!stricmp(line2,"is_in_party") || !stricmp(line2,"is_in_party?")
|| !stricmp(line2,"in_party") || !stricmp(line2,"in_party?"))
    {
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    for(r=0;r<MAX_MEMBERS;r++)
        if(party[r] == npc)
            {
            Set_tFlag("true",1);
            Set_tFlag("false",0);
            }
    return 16;
    }

if(!stricmp(line2,"on_exit_call") || !stricmp(line2,"on_exit_call=")
|| !stricmp(line2,"at_exit_call") || !stricmp(line2,"at_exit_call=")
|| !stricmp(line2,"call_at_exit") || !stricmp(line2,"call_at_exit=")
|| !stricmp(line2,"call_on_exit") || !stricmp(line2,"call_on_exit=")
|| !stricmp(line2,"at_exit_callvrm") || !stricmp(line2,"at_exit_callvrm=")
|| !stricmp(line2,"at_exit_call_vrm") || !stricmp(line2,"at_exit_call_vrm=")
|| !stricmp(line2,"on_exit_callvrm") || !stricmp(line2,"on_exit_callvrm=")
|| !stricmp(line2,"on_exit_call_vrm") || !stricmp(line2,"on_exit_call_vrm="))
    {
    strcpy(exitvrm,strrest(line1));
    strstrip(exitvrm);
    return 17;
    }

if(!stricmp(line2,"am_carrying") || !stricmp(line2,"is_carrying")
|| !stricmp(line2,"is_in_pocket"))
    {
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    strcpy(temp,strgetword(line,2));
    strdeck(temp,']');
    strstrip(temp);
    for(obj=player->pocket;obj;obj=obj->next)
      if(obj->flags.on)
        if(!stricmp(obj->name,temp))
            {
            Set_tFlag("true",1);
            Set_tFlag("false",0);
            return 18;
            }
    return 18;
    }

if(!stricmp(line2,"are_there"))
    {
    strcpy(temp,strgetword(line,2));
    r = atoi(temp);
    strcpy(temp,strgetword(line,3));
    strdeck(temp,']');
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    if(SumObjects(player,temp,0)>=r)
        {
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        }
    return 18;
    }

// Take from Player and give to the guy you're talking to

if(!stricmp(line2,"take"))
    {
    strcpy(temp,strgetword(line,2));
    r = atoi(temp);
    strcpy(temp,strgetword(line,3));
    strdeck(temp,']');
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    if(MoveQuantity(player,npc,temp,r))
        {
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        }
    return 19;
    }

// Give to player, take from guy you're talking to

if(!stricmp(line2,"give"))
    {
    strcpy(temp,strgetword(line,2));
    r = atoi(temp);
    strcpy(temp,strgetword(line,3));
    strdeck(temp,']');
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    if(TakeQuantity(npc,temp,r))
        {
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        AddQuantity(player,temp,r);
        }
    return 20;
    }

// Set behaviour

/*
if(!stricmp(line2,"setbehave") || !stricmp(line2,"setbehave=")
|| !stricmp(line2,"setbehaviour") || !stricmp(line2,"setbehaviour=")
|| !stricmp(line2,"behaviour") || !stricmp(line2,"behaviour=")
|| !stricmp(line2,"setbehavior") || !stricmp(line2,"setbehavior=")
|| !stricmp(line2,"behavior") || !stricmp(line2,"behavior="))
    {
    strcpy(temp,rest(line1));
    strstrip(temp);
    r = getnum4VRM(temp);
    if(r)
        npc->behave = getnum4VRM(r);
    strcpy(temp,"\0");
    return 21;
    }
*/
// Karma

if(!stricmp(line2,"add_karma") || !stricmp(line2,"add_karma=")
|| !stricmp(line2,"addkarma") || !stricmp(line2,"addkarma="))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = atoi(temp);
    if(r)
        player->stats->karma += r;
    strcpy(temp,"\0");
    return 22;
    }

if(!stricmp(line2,"sub_karma") || !stricmp(line2,"sub_karma=")
|| !stricmp(line2,"subkarma") || !stricmp(line2,"subkarma="))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = atoi(temp);
    if(r)
        player->stats->karma -= r;
    strcpy(temp,"\0");
    return 22;
    }

if(!stricmp(line2,"set_karma") || !stricmp(line2,"set_karma=")
|| !stricmp(line2,"setkarma") || !stricmp(line2,"setkarma="))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = atoi(temp);
    if(r)
        player->stats->karma = r;
    strcpy(temp,"\0");
    return 22;
    }

if(!stricmp(line2,"is_onscreen") || !stricmp(line2,"is_on_screen")
|| !stricmp(line2,"isonscreen"))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    if(IsOnscreen(temp))
        {
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        }
    return 23;
    }

if(!stricmp(line2,"choosemember") || !stricmp(line2,"choose_member")
|| !stricmp(line2,"chooseparty") || !stricmp(line2,"choose_party"))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    Set_tFlag("true",0);
    Set_tFlag("false",1);
    victim = ChoosePartyMember();
    if(victim)
        {
        strcpy(autolink,temp);
        link_now=1;
        Set_tFlag("true",1);
        Set_tFlag("false",0);
        }
    return 24;
    }

if(!stricmp(line2,"iftime") || !stricmp(line2,"if_time")
|| !stricmp(line2,"iftimeis") || !stricmp(line2,"if_time_is"))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = sscanf(temp,"%d-%d",&g,&b);
    if(r<2 || g>b)
        {
        Bug("Error in if_time command in %s:%d\n",curfile,curline);
        return 25;
        }
    else
        {
        r = (game_hour * 100) + game_minute;
        if( r >= g && r <= b)
            {
            pos=strchr(line,']');
            if(!pos)
                {
                Bug("Missing ] in %s:%d\n",curfile,curline);
                return 25;
                }
            pos++;

            if(pos[0]=='[')
                return(NPC_ParseCode(pos));
            else
                irecon_printxy(0,y+=8,pos);
            }
        }
    return 25;
    }

if(!stricmp(line2,"ifntime") || !stricmp(line2,"if_not_time")
|| !stricmp(line2,"ifntimeis") || !stricmp(line2,"if_not_time_is"))
    {
    strcpy(temp,strrest(line1));
    strstrip(temp);
    r = sscanf(temp,"%d-%d",&g,&b);
    if(r<2 || g>b)
        {
        Bug("Error in if_not_time command in %s:%d\n",curfile,curline);
        return 25;
        }
    else
        {
        r = (game_hour * 100) + game_minute;
        if(!(r >= g && r <= b))
            {
            pos=strchr(line,']');
            if(!pos)
                {
                Bug("Missing ] in %s:%d\n",curfile,curline);
                return 25;
                }
            pos++;

            if(pos[0]=='[')
                return(NPC_ParseCode(pos));
            else
                irecon_printxy(0,y+=8,pos);
            }
        }
    return 25;
    }

if(!stricmp(line2,"knowname") || !stricmp(line2,"know_name")
|| !stricmp(line2,"learnname") || !stricmp(line2,"learn_name"))
    {
    npc->stats->npcflags.know_name=1; // Learn their name
    return 26;
    }

if(!stricmp(line2,"ifknowname") || !stricmp(line2,"if_know_name")
|| !stricmp(line2,"if_knowname"))
    {
    if(npc->stats->npcflags.know_name)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 27;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 27;
    }

if(!stricmp(line2,"ifnknowname") || !stricmp(line2,"if_not_know_name")
|| !stricmp(line2,"if_not_knowname") || !stricmp(line2,"if_nknowname"))
    {
    if(!npc->stats->npcflags.know_name)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 27;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 27;
    }

if(!stricmp(line2,"ifplayermale") || !stricmp(line2,"if_player_male")
|| !stricmp(line2,"if_male"))
    {
    if(!player->stats->npcflags.female)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 28;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 28;
    }

if(!stricmp(line2,"ifplayerfemale") || !stricmp(line2,"if_player_female")
|| !stricmp(line2,"if_female"))
    {
    if(player->stats->npcflags.female)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 28;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 28;
    }

if(!stricmp(line2,"ifplayerhero") || !stricmp(line2,"if_player_hero")
|| !stricmp(line2,"if_hero"))
    {
    if(player->stats->npcflags.is_hero)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 29;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 29;
    }

if(!stricmp(line2,"ifnplayerhero") || !stricmp(line2,"if_not_player_hero")
|| !stricmp(line2,"if_not_hero"))
    {
    if(!player->stats->npcflags.is_hero)
        {
        pos=strchr(line,']');
        if(!pos)
            {
            Bug("Missing ] in %s:%d\n",curfile,curline);
            return 29;
            }
        pos++;

        if(pos[0]=='[')
            return(NPC_ParseCode(pos));
        else
            irecon_printxy(0,y+=8,pos);
        }
    return 29;
    }

if(!stricmp(line2,"escpage") || !stricmp(line2,"escpage=")
|| !stricmp(line2,"esc") || !stricmp(line2,"esc="))
    {
    strcpy(esclink,strrest(line1));
    strstrip(esclink);
    return 4;
    }

ilog_quiet("Parse error in file '%s':\n>>%s\n",curfile,line);
return 0;
}

/*
 *      NPC_GetPageLine(title) - Find the string '[page="title"]' and return
 *                               the line number where it's found without any
 *                               additional processing
 */

int NPC_GetPageLine(char *page)
{
char line1[1024];
char line2[1024];
int ctr;

if(!page)
    return -1;

if(!stricmp(page,"exit"))       // exit is a virtual page
    return -2;

for(ctr=0;ctr<conversation.lines;ctr++)
    {
    strcpy(line1,conversation.line[ctr]);

    strdeck(line1,'[');
    strdeck(line1,'\"');
    strdeck(line1,']');
    strdeck(line1,0xa);
    strdeck(line1,0xd);
    strstrip(line1);

    strcpy(line2,strfirst(line1));

    if(!stricmp(line2,"page") || !stricmp(line2,"page="))
        {
        strcpy(line2,strrest(line1));
        strstrip(line2);
        if(!stricmp(line2,page))
            return ctr;
        }
    }
return -1;
}

/*
 *      NPC_GetPage(title) - Find the string '[page="title"]' and return
 *                           the line number where it's found
 */

int NPC_GetPage(char *name)
{
int ctr;
char prev_scanonly;

////itg_memset(bg_screen,0,itg_blitsize);    // Make sure it's clear
clear(swapscreen);

if(!stricmp(name,"exit"))
    return -2;
prev_scanonly=scan_only;
scan_only=1;
for(ctr=0;ctr<conversation.lines;ctr++)
    if(NPC_ParseCode(conversation.line[ctr]) == 2)
        {
        if(!stricmp(curpage,name))
            {
            scan_only=prev_scanonly;
            return ctr;
            }
        }
scan_only=prev_scanonly;
return -1;
}

/*
 *      NPC_GetEnd(starting link) - Find the end of the current page
 */

int NPC_GetEnd(int start)
{
int ctr,lines;
lines=conversation.lines;
if(start<0)
    return -1;
scan_only=1;
for(ctr=start;ctr<lines;ctr++)
    if(NPC_ParseCode(conversation.line[ctr]) == 3)
        {
        scan_only=0;
        return ctr;
        }
scan_only=0;
return lines;
}

/*
 *      NPC_ResetLinks() - Erase the links table
 */

void NPC_ResetLinks()
{
linkptr=0;
return;
}

/*
 *      NPC_AddLink(title,address) - Add a link to the table
 */

void NPC_AddLink(char *msg, char *dest)
{
if(linkptr>=10)
    {
    Bug("Too many links in page '%s' in %s:%d\n",curpage,curfile,curline);
    return;
    }
strcpy(links[linkptr][0],msg);
strcpy(links[linkptr][1],dest);
strstrip(links[linkptr][0]);
strstrip(links[linkptr][1]);
strcpy(links[linkptr][2],"\0");  // Initialise for later
strcpy(links[linkptr][3],"\0");
linkptr++;
}

/*
 *      NPC_AltLinkM(title) - Add alternate link title to the table
 */

void NPC_AltLinkM(char *msg)
{
if(linkptr<1)
    {
    Bug("AltLink before LinkTo in page '%s' in %s:%d\n",curpage,curfile,curline);
    return;
    }
strcpy(links[linkptr-1][3],msg);
strstrip(links[linkptr-1][3]);
}

/*
 *      NPC_AltLinkD(address) - Add alternate Dest to the table
 */

void NPC_AltLinkD(char *dest)
{
if(linkptr<1)
    {
    Bug("AltLinkTo before LinkTo in page '%s' in %s:%d\n",curpage,curfile,curline);
    return;
    }
strcpy(links[linkptr-1][2],dest);
strstrip(links[linkptr-1][2]);
}

/*
 *      toke(string) - search for and expand any system tokens in the string.
 *                     Modifies the given string so be sure it's not floating.
 *                     Calls toker.
 */

void toke(char *string)
{
for(;toker(string););	// Call it until there's nothing left to do.
}

/*
 *      toker(string) - Does the work.
 */

int toker(char *string)
{
char *a,*b;
char temp[1024];
char token[128];
char got_quote=0,notail=0;
char punctuation[]="  \0\0\0\0";
int k,ctr;

char *censor[][2]=
	{
		{"Fuck","F***",},
		{"fuck","f***",},
		{"Shit","S***",},
		{"shit","s***",},
		{"Crap","C***",},
		{"crap","c***",},
		{"Bugger","B*****",},
		{"bugger","b*****",},
		{"Bastard","B******",},
		{"bastard","b******",},
		{NULL,NULL}
	};

a=strchr(string,'$');
if(!a)
    return 0;      // No special tokens, don't need to change it
*a=0; // smash the token symbol away

notail=0;

strcpy(temp,string);    // All up to the token
strcpy(token,(a+1));    // Copy the token to buffer

ilog_quiet("token = '%s'\n",token);

// Do we have an end quote at the end of the token?

b=strrchr(token,'\"');
if(b)
	{
	*b=0;	// Kill it, my cyborgs
	got_quote=1;
	}

// Make the token just one word
b=strrest(token);
if(b != NOTHING)
	*b=0;

strstrip(token);

punctuation[0]=' ';
k=strlen(token);

if(strrest(a+1) == NOTHING)
	notail=1;

if(k>1)
	{
	// Several cases where we deal with punctuation.

	// Case 1.  "name." the name, followed by a terminator, e.g. !?.
	if(token[k-1] == '?' || token[k-1] == '!' || token[k-1] == '.')      //if(token[k-1]<'a' && token[k-1]<'A')
		{
		punctuation[0]=token[k-1];
		if(got_quote && notail)
			{
			punctuation[1]='\"';
			punctuation[2]=0; // Two spaces after a terminator.
			}
		else
			{
			punctuation[1]=' ';
			punctuation[2]=' ';
			punctuation[3]=0; // Two spaces after a terminator.
			}
		token[k-1]=0;
		}
	else // Case 2.  "name," the name, followed by a single punctuation mark
	if(token[k-1]<'A')      //if(token[k-1]<'a' && token[k-1]<'A')
		{
		punctuation[0]=token[k-1];
		token[k-1]=0;
		}
	else // Case 3.  "name's" the name, followed by apostrophe and 's'
	if(token[k-2]=='\'' && token[k-1]=='s')
		{
		punctuation[0]='\'';
		punctuation[1]='s';
		punctuation[2]=' ';
		token[k-2]=0;
		}
	else // Case 4.  "name" No punctuation at all.
		punctuation[1]=0;
	}
	else
		punctuation[1]=0; // default

if(got_quote) // Add quote to the end of the line as necessary
	{
	k=strlen(punctuation)-1;
	if(k>0)
		{
		if(punctuation[k]==' ') // If there's a space, remove it
			punctuation[k]=0;
		if(punctuation[k]=='\"') // If there's already one, remove it
			punctuation[k]=0;
		}
	if(notail)
		strcat(punctuation,"\"");
	}

if(!strcmp(token,"PLAYER"))
    {
    strcat(temp,player->personalname);
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"CHARNAME"))
    {
	strcat(temp,npc->personalname);
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"OBJNAME"))
    {
    strcat(temp,objname);
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"DECODE"))
    {
    strcat(temp,put_time(strfirst(strrest(a+1))));
//    strcat(temp,punctuation);
    strcat(temp,strrest(strrest(a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"SIR"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"Madam");
    else
        strcat(temp,"Sir");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"He"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"She");
    else
        strcat(temp,"He");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"he"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"she");
    else
        strcat(temp,"he");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"LORD"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"Lord");
    else
        strcat(temp,"Lady");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"MILORD"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"Milord");
    else
        strcat(temp,"Milady");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"MR"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"Mr.");
    else
        strcat(temp,"Miss");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

if(!strcmp(token,"MASTER"))
    {
    if(player->stats->npcflags.female)
        strcat(temp,"master");
    else
        strcat(temp,"mistress");
    strcat(temp,punctuation);
    strcat(temp,strrest((a+1)));
    strcpy(string,temp);
    return 1;
    }

// Censor 'bad words' ;-)

for(ctr=0;censor[ctr][0];ctr++)
	if(!strcmp(token,censor[ctr][0]))
		{
		if(enable_censorware)
			strcat(temp,censor[ctr][1]);
		else
			strcat(temp,censor[ctr][0]);
		strcat(temp,punctuation);
		strcat(temp,strrest((a+1)));
		strcpy(string,temp);
		return 1;
		}

return 0;
}


/*
void NPC_DisplayFile(char *file)
{
int k,i,lines;
conversation.init(file);

i=0;
lines=50;
k=-1;

if(lines>conversation.lines)
    lines=conversation.lines;

SYS_KEY_FLUSH();
do  {
    itg_memset(swapscreen,0,itg_blitsize);
    for(int ctr=0;ctr<lines;ctr++)
        C_printxy(0,ctr<<3,conversation.line[ctr+i]);
    itg_update(swapscreen);
    k=SYS_KEY_WAIT();
    if(k == KEY_UP)
         {
         i--;
         if(i<0)
             i=0;
         }
    if(k == KEY_DOWN)
         {
         i++;
         if(i>conversation.lines-lines)
             i=conversation.lines-lines;
         }
    } while(k!=KEY_ESC);
SYS_KEY_FLUSH();

conversation.term();
}
*/

/*
 *    Change or create a personal flag
 */

void setPflag(OBJECT *o,int n,int s)
{
int bit,mask;
if(n<0 || n>31)
    {
    Bug("Attempt to set invalid p-flag %d for object %s.\n",n,o->name);
    return;
    }

bit = 1<<n;
mask = bit ^ 0xffffffff;
if(s)
    o->stats->pFlags |= bit;
else
    o->stats->pFlags &= mask;
}

/*
 *    Get state of a personal flag
 */

int getPflag(OBJECT *o,int n)
{
int bit;
if(n<0 || n>31)
    {
    Bug("Attempt to query invalid p-flag %d for object %s.\n",n,o->name);
    return 0;
    }

bit = 1<<n;
return (o->stats->pFlags & bit);
}

/*
 *    Reset all user-named game flags
 */

void NPC_Init()
{
int ctr;
for(ctr=0;ctr<MAXFLAGS;ctr++)
    {
    tFlag[ctr]=0;
    tFlagIdentifier[ctr]=NULL;
    }
numFlags=0;
}

/*
 *    Destroy all user-named game flags
 */

void Wipe_tFlags()
{
int ctr;
for(ctr=0;ctr<MAXFLAGS;ctr++)
	{
	tFlag[ctr]=0;
	if(tFlagIdentifier[ctr])
		{
		M_free(tFlagIdentifier[ctr]);
		tFlagIdentifier[ctr]=NULL;
		}
	}
numFlags=0;
}

/*
 *    Get state of a user-named game flag
 */

int Get_tFlag(char *name)
{
int ctr;

for(ctr=0;ctr<=numFlags;ctr++)
	if(tFlagIdentifier[ctr])
		if(!stricmp(tFlagIdentifier[ctr],name))
			{
//		ilog_printf("match flag %s,%s does exist\n",tFlagIdentifier[ctr],name);
			return(tFlag[ctr]);
			}
return 0;
}

/*
 *    Change or create a user-named game flag
 */

void Set_tFlag(char *name,int a)
{
int ctr,len;

for(ctr=0;ctr<MAXFLAGS;ctr++)
	if(tFlagIdentifier[ctr])
		{
		if(!stricmp(tFlagIdentifier[ctr],name))
			{
			tFlag[ctr]=a;
//            ilog_printf("match flag %s,%s set to %d\n",tFlagIdentifier[ctr],name,a);
			return;
			}
		}
	else
		{
		len = strlen(name);
		tFlagIdentifier[ctr]=(char *)M_get(1,len+1);
		strcpy(tFlagIdentifier[ctr],name);
		tFlag[ctr]=a;
		numFlags=ctr+1;
		return;
		}

ithe_panic("Set_tFlag: Too many flags defined: attempted to make flag called:",name);
}


/*
 *    Show a list of (max 9) party members and wait for user input
 */

OBJECT *ChoosePartyMember()
{
int ctr,members,k;
char msg[5];

//SYS_KEY_FLUSH();
FlushKeys();
members=0;
for(ctr=0;ctr<MAX_MEMBERS;ctr++)
    if(party[ctr])
        members++;

irecon_colour(0,0,160);

y+=32;
for(ctr=0;ctr<members;ctr++)
    {
    itoa(ctr+1,msg,10);
    irecon_printxy(0,y,msg);
    if(party[ctr]->personalname)
        irecon_printxy(16,y,party[ctr]->personalname);
    else
        irecon_printxy(16,y,party[ctr]->name);
    y+=8;
    }

irecon_printxy(0,y,"0");
irecon_printxy(16,y,"No-one");
y+=8;

irecon_colour(def_r,def_g,def_b);

Show();

do  {
    FlushKeys();
    k=WaitForKey();
    ctr=0;
    if(k>= KEY_0 && k<= KEY_9)
        ctr=1;
    } while(!ctr);

if(k == KEY_0)
    return NULL;

return (party[k-KEY_1]);
}

/*
 *      Record that a link has been traversed for this character
 */

void NPC_BeenRead(OBJECT *o,char *page, OBJECT *p)
{
NPC_RECORDING *temp;

if(!o)     // Press F1 for Help has no object attached to it
    return;
if(!p)
	return; // If no 'player' involved

if(!o->stats)
    ithe_panic("NPC_BeenRead: Passed invalid object (no stats)",o->name);

// Empty list

if(o->stats->npctalk == NULL)
    {
    temp = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
    o->stats->npctalk = temp;
    temp->next = NULL;
    temp->page = (char *)M_get(1,strlen(page)+1);
	temp->player = p;
    strcpy(temp->page,page);
    return;
    }

// Non-empty list, skip if already present

for(temp=o->stats->npctalk;temp->next;temp=temp->next)
    if(!stricmp(temp->page,page) && temp->player == p)
        return;

// Add new entry to end of list

temp->next = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
temp->next->next = NULL;
temp->next->page = (char *)M_get(1,strlen(page)+1);
temp->next->player = p;
strcpy(temp->next->page,page);
}

void NPC_lFlag(OBJECT *o,char *page, OBJECT *p)
{
NPC_RECORDING *temp;

if(!o)     // Press F1 for Help has no object attached to it
    return;
if(!p)
	return; // If no 'player' involved

if(!o->stats)
    ithe_panic("NPC_UnRead: Passed invalid object (no stats)",o->name);

// Empty list

if(o->stats->npctalk == NULL)
    {
    temp = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
    o->stats->npctalk = temp;
    temp->next = NULL;
    temp->page = (char *)M_get(1,strlen(page)+1);
	temp->player = p;
    strcpy(temp->page,page);
    return;
    }

// Non-empty list, skip if already present

for(temp=o->stats->npctalk;temp->next;temp=temp->next)
    if(!stricmp(temp->page,page) && temp->player == p)
        return;

// Look for an empty slot and use that if possible

for(temp=o->stats->npctalk;temp->next;temp=temp->next)
    if(temp->page[0]=='\0' && temp->player == NULL)
		{
		M_free(temp->page);
		temp->page = (char *)M_get(1,strlen(page)+1);
		temp->player = p;
		return;
		}

// Add new entry to end of list

temp->next = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
temp->next->next = NULL;
temp->next->page = (char *)M_get(1,strlen(page)+1);
temp->next->player = p;
strcpy(temp->next->page,page);
}

/*
 *      Found out if a link has been traversed for this character
 */

int NPC_WasRead(OBJECT *o,char *page)
{
NPC_RECORDING *temp;

if(!o)     // Press F1 for Help has no object attached to it
    return 0;

for(temp=o->stats->npctalk;temp;temp=temp->next)
    if(!stricmp(temp->page,page) && temp->player == player)
        return(1);
return 0;
}

/*
 *      Add or delete an lFlag
 */

void NPC_set_lFlag(OBJECT *o,char *page, OBJECT *p, int state)
{
NPC_RECORDING *temp,*temp2;

if(!o)     // Press F1 for Help has no object attached to it
    return;
if(!p)
	return; // If no 'player' involved

if(!o->stats)
    ithe_panic("NPC_set_lFlag: Passed invalid object (no stats)",o->name);

// Empty list

if(o->stats->lFlags == NULL)
    {
	if(!state)
		return; // Not there, don't bother to delete it
    temp = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
    o->stats->lFlags = temp;
    temp->next = NULL;
    temp->page = (char *)M_get(1,strlen(page)+1);
	temp->player = p;
    strcpy(temp->page,page);
    return;
    }

// Non-empty list, skip if already present

for(temp=o->stats->lFlags;temp->next;temp=temp->next)
    if(!stricmp(temp->page,page) && temp->player == p)
		{
		if(state)
			return;	// Already there, don't add
		// Mark unused
		temp->page[0]='\0';
		temp->player=NULL;
		return;
		}

if(!state)
	return; // It wasn't there, don't remove it

// Look for an empty slot and use that if possible

for(temp=o->stats->lFlags;temp->next;temp=temp->next)
    if(temp->page[0]=='\0' && temp->player == NULL)
		{
		M_free(temp->page);
		temp->page = (char *)M_get(1,strlen(page)+1);
		temp->player = p;
		return;
		}

// Ok, add new entry to end of list

temp->next = (NPC_RECORDING *)M_get(1,sizeof(NPC_RECORDING));
temp->next->next = NULL;
temp->next->page = (char *)M_get(1,strlen(page)+1);
temp->next->player = p;
strcpy(temp->next->page,page);
}

/*
 *      Found out if an lFlag has been set for this character
 */

int NPC_get_lFlag(OBJECT *o,char *page, OBJECT *p)
{
NPC_RECORDING *temp;

if(!o)     // Press F1 for Help has no object attached to it
    return 0;
if(!p)
	return 0; // If no 'player' involved

for(temp=o->stats->lFlags;temp;temp=temp->next)
    if(!stricmp(temp->page,page) && temp->player == p)
        return(1);
return 0;
}

/*
 *      Delete all list entries
 */

void NPC_ReadWipe(OBJECT *o)
{
NPC_RECORDING *temp,*old;

if(!o)     // Press F1 for Help has no object attached to it
    return;

// First the Npc talk

old=o->stats->npctalk;
for(temp=old;temp;)
	if(temp)
		{
		temp=temp->next;
		old->next=NULL; // break the list in case of error
		if(old->page)
			M_free(old->page);
		M_free(old);
		old=temp;
		}
o->stats->npctalk=NULL;

// Then the lFlags

old=o->stats->lFlags;
for(temp=old;temp;)
	if(temp)
		{
		temp=temp->next;
		old->next=NULL; // break the list in case of error
		if(old->page)
			M_free(old->page);
		M_free(old);
		old=temp;
		}
o->stats->lFlags=NULL;
}



