/*
 *      IRE - text file routines, loading and indexing thru' VFS layer
 */

#include <stdio.h>
#include <allegro.h>
#include "textfile.h"
#include "loadfile.h"

// set values to reasonable defaults

void TF_init(struct TF_S *s)
{
if(!s)
  	return;
s->size=0;
s->lines=0;
s->block=NULL;
s->line=NULL;
}

// free memory if necessary and set to defaults

void TF_term(struct TF_S *s)
{
if(s->size)
	{
    if(s->block)
    	{
//            memset(block,0,size);
        M_free(s->block);
        }
    s->size=0;
    }
if(s->lines)
    {
    if(s->line)
        M_free(s->line);
    s->lines=0;
    }
}

// open file, alloc memory and index by line

void TF_load(struct TF_S *s, char *filename)
{
int ctr,current,len;
char fn[1024];
IFILE *fp;

if(!loadfile(filename,fn))
	ithe_panic("Could not open text file:",filename);

fp=iopen(fn);          // Open file
s->size = ifilelength(fp);
s->block = (char *)M_get(1,s->size+1);    // Alloc memory for block, and a NULL
iread(s->block,s->size,fp);          // Read the file into block
iclose(fp);                        // Finished

s->lines = 1;                     // Count Carriage Returns

for(ctr = 0;ctr < s->size;ctr++)
	if(s->block[ctr] == '\n')   // Found one
    	s->lines++;

// We now know how many lines there are, so allocate the line index

s->line = (char **)M_get(s->lines,sizeof(char *));

// Now we go through the lines indexing them.

current = 0;                                	// First line
s->line[0] = s->block;                        	// This is the first line

for(ctr = 0;ctr < s->size;ctr++)
	if(s->block[ctr] == '\n')               	// Found a line break
		{
		s->block[ctr] = 0;                   	// End the string
		s->line[++current] = &s->block[ctr+1];  // This is the next line
		}
}
